/*
 * ********************************************************************************************************************
 *
 *               iFHS7.
 *              ;BBMBMBMc                  rZMBMBR              BMB
 *              MBEr:;PBM,               7MBMMEOBB:             BBB                       RBW
 *     XK:      BO     SB.     :SZ       MBM.       c;;     ir  BBM :FFr       :SSF:    ;xBMB:r   iuGXv.    i:. iF2;
 *     DBBM0r.  :D     S7   ;XMBMB       GMBMu.     MBM:   BMB  MBMBBBMBMS   WMBMBMBBK  MBMBMBM  BMBRBMBW  .MBMBMBMBB
 *      :JMRMMD  ..    ,  1MMRM1;         ;MBMBBR:   MBM  ;MB:  BMB:   MBM. RMBr   sBMH   BM0         UMB,  BMB.  KMBv
 *     ;.   XOW  B1; :uM: 1RE,   i           .2BMBs  rMB. MBO   MBO    JMB; MBB     MBM   BBS    7MBMBOBM:  MBW   :BMc
 *     OBRJ.SEE  MRDOWOR, 3DE:7OBM       .     ;BMB   RMR7BM    BMB    MBB. BMB    ,BMR  .BBZ   MMB   rMB,  BMM   rMB7
 *     :FBRO0D0  RKXSXPR. JOKOOMPi       BMBSSWBMB;    BMBB:    MBMB0ZMBMS  .BMBOXRBMB    MBMDE RBM2;SMBM;  MBB   xBM2
 *         iZGE  O0SHSPO. uGZ7.          sBMBMBDL      :BMO     OZu:BMBK,     rRBMB0;     ,EBMB  xBMBr:ER.  RDU   :OO;
 *     ,BZ, 1D0  RPSFHXR. xWZ .SMr                  . .BBB
 *      :0BMRDG  RESSSKR. 2WOMBW;                   BMBMR
 *         i0BM: SWKHKGO  MBDv
 *           .UB  OOGDM. MK,                                          Copyright (c) 2015-2019.  斯伯坦机器人
 *              ,  XMW  ..
 *                  r                                                                     All rights reserved.
 *
 * ********************************************************************************************************************
 */

package com.sybotan.service.utils

import org.springframework.beans.factory.support.BeanDefinitionBuilder
import org.springframework.beans.factory.support.DefaultListableBeanFactory
import org.springframework.context.ApplicationContext

/**
 * Bean工具类
 *
 * @author  庞利祥 <sybotan@126.com>
 */
object SBeanUtil {

    /**
     * 动态注册Bean
     *
     * @param   ctx     应用上下文
     * @param   clz     Bean对应的类
     * @param   name    Bean名称
     */
    fun registBeanDefinition(ctx: ApplicationContext, clz: Class<*>, name: String) {
        val defaultBeanFactory = ctx.autowireCapableBeanFactory as (DefaultListableBeanFactory)
        val beanDefinitionBuilder = BeanDefinitionBuilder.genericBeanDefinition(clz)
        //beanDefinitionBuilder.addPropertyValue("name", name)
        defaultBeanFactory.registerBeanDefinition(name, beanDefinitionBuilder.beanDefinition)
        defaultBeanFactory.removeBeanDefinition(name)
        return
    } // Fun registBeanDefinition()

    /**
     * 动态删除注册的Bean
     *
     * @param   ctx     应用上下文
     * @param   name    Bean名称
     */
    fun removeBeanDefinition(ctx: ApplicationContext, name: String) {
        val defaultBeanFactory = ctx.autowireCapableBeanFactory as (DefaultListableBeanFactory)
        defaultBeanFactory.removeBeanDefinition(name)
        return
    } // Fun removeBeanDefinition()
} // Class SBeanUtil()