/*
 * ********************************************************************************************************************
 *
 *               iFHS7.
 *              ;BBMBMBMc                  rZMBMBR              BMB
 *              MBEr:;PBM,               7MBMMEOBB:             BBB                       RBW
 *     XK:      BO     SB.     :SZ       MBM.       c;;     ir  BBM :FFr       :SSF:    ;xBMB:r   iuGXv.    i:. iF2;
 *     DBBM0r.  :D     S7   ;XMBMB       GMBMu.     MBM:   BMB  MBMBBBMBMS   WMBMBMBBK  MBMBMBM  BMBRBMBW  .MBMBMBMBB
 *      :JMRMMD  ..    ,  1MMRM1;         ;MBMBBR:   MBM  ;MB:  BMB:   MBM. RMBr   sBMH   BM0         UMB,  BMB.  KMBv
 *     ;.   XOW  B1; :uM: 1RE,   i           .2BMBs  rMB. MBO   MBO    JMB; MBB     MBM   BBS    7MBMBOBM:  MBW   :BMc
 *     OBRJ.SEE  MRDOWOR, 3DE:7OBM       .     ;BMB   RMR7BM    BMB    MBB. BMB    ,BMR  .BBZ   MMB   rMB,  BMM   rMB7
 *     :FBRO0D0  RKXSXPR. JOKOOMPi       BMBSSWBMB;    BMBB:    MBMB0ZMBMS  .BMBOXRBMB    MBMDE RBM2;SMBM;  MBB   xBM2
 *         iZGE  O0SHSPO. uGZ7.          sBMBMBDL      :BMO     OZu:BMBK,     rRBMB0;     ,EBMB  xBMBr:ER.  RDU   :OO;
 *     ,BZ, 1D0  RPSFHXR. xWZ .SMr                  . .BBB
 *      :0BMRDG  RESSSKR. 2WOMBW;                   BMBMR
 *         i0BM: SWKHKGO  MBDv
 *           .UB  OOGDM. MK,                                          Copyright (c) 2015-2019.  斯伯坦机器人
 *              ,  XMW  ..
 *                  r                                                                     All rights reserved.
 *
 * ********************************************************************************************************************
 */

package com.sybotan.service.utils.crypt

import javax.crypto.Cipher
import javax.crypto.SecretKeyFactory
import javax.crypto.spec.PBEKeySpec
import javax.crypto.spec.PBEParameterSpec
import java.security.Key

abstract class SPBECoderUtil : SCoderUtil() {
    companion object {
        const val ALGORITHM = "PBEWITHMD5andDES"

        // 初始化盐为20090421
        private val salt = "20090421".toByteArray()

        /**
         * 转换密钥<br></br>
         *
         * @param password
         * @return
         * @throws Exception
         */
        @Throws(Exception::class)
        private fun toKey(password: String): Key {
            val keySpec = PBEKeySpec(password.toCharArray())
            val keyFactory = SecretKeyFactory.getInstance(ALGORITHM)

            return keyFactory.generateSecret(keySpec)
        } // Fun toKey()

        /**
         * 加密
         *
         * @param data     数据
         * @param password 密码
         * @return
         * @throws Exception
         */
        @Throws(Exception::class)
        fun encrypt(data: ByteArray, password: String): ByteArray {

            val key = toKey(password)

            val paramSpec = PBEParameterSpec(salt, 100)
            val cipher = Cipher.getInstance(ALGORITHM)
            cipher.init(Cipher.ENCRYPT_MODE, key, paramSpec)

            return cipher.doFinal(data)
        } // Fun encrypt()

        /**
         * 加密
         *
         * @param data     数据
         * @return
         * @throws Exception
         */
        @Throws(Exception::class)
        fun encrypt(data: ByteArray): ByteArray {

            val key = toKey("Sybot-20090421")

            val paramSpec = PBEParameterSpec(salt, 100)
            val cipher = Cipher.getInstance(ALGORITHM)
            cipher.init(Cipher.ENCRYPT_MODE, key, paramSpec)

            return cipher.doFinal(data)
        } // Fun encrypt()

        /**
         * 解密
         *
         * @param data     数据
         * @param password 密码
         * @return
         * @throws Exception
         */
        @Throws(Exception::class)
        fun decrypt(data: ByteArray, password: String): ByteArray {

            val key = toKey(password)

            val paramSpec = PBEParameterSpec(salt, 100)
            val cipher = Cipher.getInstance(ALGORITHM)
            cipher.init(Cipher.DECRYPT_MODE, key, paramSpec)

            return cipher.doFinal(data)

        } // Fun decrypt()

        /**
         * 解密
         *
         * @param data     数据
         * @return
         * @throws Exception
         */
        @Throws(Exception::class)
        fun decrypt(data: ByteArray): ByteArray {

            val key = toKey("Sybot-20090421")

            val paramSpec = PBEParameterSpec(salt, 100)
            val cipher = Cipher.getInstance(ALGORITHM)
            cipher.init(Cipher.DECRYPT_MODE, key, paramSpec)

            return cipher.doFinal(data)

        } // Fun decrypt()
    }
} // Class PBECoder
