/*
 * ********************************************************************************************************************
 *
 *               iFHS7.
 *              ;BBMBMBMc                  rZMBMBR              BMB
 *              MBEr:;PBM,               7MBMMEOBB:             BBB                       RBW
 *     XK:      BO     SB.     :SZ       MBM.       c;;     ir  BBM :FFr       :SSF:    ;xBMB:r   iuGXv.    i:. iF2;
 *     DBBM0r.  :D     S7   ;XMBMB       GMBMu.     MBM:   BMB  MBMBBBMBMS   WMBMBMBBK  MBMBMBM  BMBRBMBW  .MBMBMBMBB
 *      :JMRMMD  ..    ,  1MMRM1;         ;MBMBBR:   MBM  ;MB:  BMB:   MBM. RMBr   sBMH   BM0         UMB,  BMB.  KMBv
 *     ;.   XOW  B1; :uM: 1RE,   i           .2BMBs  rMB. MBO   MBO    JMB; MBB     MBM   BBS    7MBMBOBM:  MBW   :BMc
 *     OBRJ.SEE  MRDOWOR, 3DE:7OBM       .     ;BMB   RMR7BM    BMB    MBB. BMB    ,BMR  .BBZ   MMB   rMB,  BMM   rMB7
 *     :FBRO0D0  RKXSXPR. JOKOOMPi       BMBSSWBMB;    BMBB:    MBMB0ZMBMS  .BMBOXRBMB    MBMDE RBM2;SMBM;  MBB   xBM2
 *         iZGE  O0SHSPO. uGZ7.          sBMBMBDL      :BMO     OZu:BMBK,     rRBMB0;     ,EBMB  xBMBr:ER.  RDU   :OO;
 *     ,BZ, 1D0  RPSFHXR. xWZ .SMr                  . .BBB
 *      :0BMRDG  RESSSKR. 2WOMBW;                   BMBMR
 *         i0BM: SWKHKGO  MBDv
 *           .UB  OOGDM. MK,                                          Copyright (c) 2015-2019.  斯伯坦机器人
 *              ,  XMW  ..
 *                  r                                                                     All rights reserved.
 *
 * ********************************************************************************************************************
 */

package com.sybotan.sso.models.entities

import com.sybotan.service.models.SBaseEntity
import io.swagger.annotations.ApiModel
import io.swagger.annotations.ApiModelProperty
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 单点登录用户实体类
 *
 * @author  庞利祥 <sybotan@126.com>
 */
@ApiModel(description = "单点登录用户")
@Table(name = "user")
open class SSsoUser: SBaseEntity() {
    /** 用户id */
    @ApiModelProperty(value = "用户id")
    @Id
    @Column(name = "id", updatable = false)
    var id: String? = null

    /** 用户名 */
    @ApiModelProperty(value = "用户名", required = true)
    @Column(name = "user_name")
    var userName: String? = null

    /** 密码 */
    @ApiModelProperty(value = "密码", required = true)
    //@Column(name = "password", updatable = false)
    var password: String? = null

    /** 真实姓名 */
    @ApiModelProperty(value = "真实姓名")
    var realName: String? = null

    /** 手机号码 */
    @ApiModelProperty(value = "手机号码，全局唯一")
    var phone: String? = null

    /** 邮箱 */
    @ApiModelProperty(value = "邮箱，全局唯一")
    var mail: String? = null

    /** 身份证号码 */
    @ApiModelProperty(value = "身份证号码，全局唯一")
    var certno: String? = null
} // Class SSsoUser
