/*
 * ********************************************************************************************************************
 *
 *               iFHS7.
 *              ;BBMBMBMc                  rZMBMBR              BMB
 *              MBEr:;PBM,               7MBMMEOBB:             BBB                       RBW
 *     XK:      BO     SB.     :SZ       MBM.       c;;     ir  BBM :FFr       :SSF:    ;xBMB:r   iuGXv.    i:. iF2;
 *     DBBM0r.  :D     S7   ;XMBMB       GMBMu.     MBM:   BMB  MBMBBBMBMS   WMBMBMBBK  MBMBMBM  BMBRBMBW  .MBMBMBMBB
 *      :JMRMMD  ..    ,  1MMRM1;         ;MBMBBR:   MBM  ;MB:  BMB:   MBM. RMBr   sBMH   BM0         UMB,  BMB.  KMBv
 *     ;.   XOW  B1; :uM: 1RE,   i           .2BMBs  rMB. MBO   MBO    JMB; MBB     MBM   BBS    7MBMBOBM:  MBW   :BMc
 *     OBRJ.SEE  MRDOWOR, 3DE:7OBM       .     ;BMB   RMR7BM    BMB    MBB. BMB    ,BMR  .BBZ   MMB   rMB,  BMM   rMB7
 *     :FBRO0D0  RKXSXPR. JOKOOMPi       BMBSSWBMB;    BMBB:    MBMB0ZMBMS  .BMBOXRBMB    MBMDE RBM2;SMBM;  MBB   xBM2
 *         iZGE  O0SHSPO. uGZ7.          sBMBMBDL      :BMO     OZu:BMBK,     rRBMB0;     ,EBMB  xBMBr:ER.  RDU   :OO;
 *     ,BZ, 1D0  RPSFHXR. xWZ .SMr                  . .BBB
 *      :0BMRDG  RESSSKR. 2WOMBW;                   BMBMR
 *         i0BM: SWKHKGO  MBDv
 *           .UB  OOGDM. MK,                                          Copyright (c) 2015-2019.  斯伯坦机器人
 *              ,  XMW  ..
 *                  r                                                                     All rights reserved.
 *
 * ********************************************************************************************************************
 */

package com.sybotan.service.models.responses

import com.sybotan.database.SPageQueryInfo
import com.sybotan.service.models.enums.SResponseType
import io.swagger.annotations.ApiModel
import io.swagger.annotations.ApiModelProperty

/**
 * 查询请求应答对象基类
 *
 * @author  庞利祥 <sybotan@126.com>
 */
@ApiModel(description = "查询请求应答对象基类")
open class SQueryResponse<ENTITY: Any>(result: SResponseType = SResponseType.success, message: String = "")
    : SBaseResponse(result, message) {
    /** 符合条件的总记录数 */
    @ApiModelProperty(value = "符合条件的总记录数")
    var total: Long? = null

    /** 第几页 */
    @ApiModelProperty(value = "第几页")
    var pageNumber: Int? = null

    /** 每页记录数 */
    @ApiModelProperty(value = "每页记录数")
    var pageSize: Int? = null

    /** 查询到的数据列表 */
    @ApiModelProperty(value = "查询到的数据列表")
    var content: List<ENTITY>? = null

    /**
     * 子构造函数
     *
     * @param   info    分页查询信息
     */
    constructor(info: SPageQueryInfo<ENTITY>): this(SResponseType.success, "") {
        this.total = info.total
        this.pageNumber = info.pageNumber
        this.pageSize = info.pageSize
        this.content = info.content
    } // Fun constructor()
} // Class SQueryResponse