/*
 * ********************************************************************************************************************
 *
 *               iFHS7.
 *              ;BBMBMBMc                  rZMBMBR              BMB
 *              MBEr:;PBM,               7MBMMEOBB:             BBB                       RBW
 *     XK:      BO     SB.     :SZ       MBM.       c;;     ir  BBM :FFr       :SSF:    ;xBMB:r   iuGXv.    i:. iF2;
 *     DBBM0r.  :D     S7   ;XMBMB       GMBMu.     MBM:   BMB  MBMBBBMBMS   WMBMBMBBK  MBMBMBM  BMBRBMBW  .MBMBMBMBB
 *      :JMRMMD  ..    ,  1MMRM1;         ;MBMBBR:   MBM  ;MB:  BMB:   MBM. RMBr   sBMH   BM0         UMB,  BMB.  KMBv
 *     ;.   XOW  B1; :uM: 1RE,   i           .2BMBs  rMB. MBO   MBO    JMB; MBB     MBM   BBS    7MBMBOBM:  MBW   :BMc
 *     OBRJ.SEE  MRDOWOR, 3DE:7OBM       .     ;BMB   RMR7BM    BMB    MBB. BMB    ,BMR  .BBZ   MMB   rMB,  BMM   rMB7
 *     :FBRO0D0  RKXSXPR. JOKOOMPi       BMBSSWBMB;    BMBB:    MBMB0ZMBMS  .BMBOXRBMB    MBMDE RBM2;SMBM;  MBB   xBM2
 *         iZGE  O0SHSPO. uGZ7.          sBMBMBDL      :BMO     OZu:BMBK,     rRBMB0;     ,EBMB  xBMBr:ER.  RDU   :OO;
 *     ,BZ, 1D0  RPSFHXR. xWZ .SMr                  . .BBB
 *      :0BMRDG  RESSSKR. 2WOMBW;                   BMBMR
 *         i0BM: SWKHKGO  MBDv
 *           .UB  OOGDM. MK,                                          Copyright (c) 2015-2019.  斯伯坦机器人
 *              ,  XMW  ..
 *                  r                                                                     All rights reserved.
 *
 * ********************************************************************************************************************
 */

package com.sybotan.mybatis

import com.alibaba.druid.pool.DruidDataSource
import com.sybotan.service.utils.SSpringContextUtil
import org.mybatis.spring.SqlSessionTemplate
import javax.sql.DataSource

/**
 * Mybatis基础Dao操作
 *
 * @author 庞利祥 <sybotan@126.com>
 */
open class SMybatisDao<ENTITY: Any>(entityClazz: Class<ENTITY>, val mapperClass: Class<*>? = null) : SAbstractMybatisDao<ENTITY>(entityClazz) {
    companion object {
        /** sql会话 */
        val sqlSession: SqlSessionTemplate by lazy {
            val dataSource = SSpringContextUtil.getBean(DataSource::class.java) as DruidDataSource
            SSqlProvider.driver = when (dataSource.driverClassName) {
                "org.postgresql.Driver" ->
                    Class.forName("com.sybotan.postgresql.SPostgreSqlDriver").newInstance() as SAbstractDriver
                "com.mysql.cj.jdbc.Driver" ->
                    Class.forName("com.sybotan.mysql.SMySqlDriver").newInstance() as SAbstractDriver
                else ->
                    Class.forName("com.sybotan.postgresql.SPostgreSqlDriver").newInstance() as SAbstractDriver
            }
            SSpringContextUtil.getBean(SqlSessionTemplate::class.java) as SqlSessionTemplate
        }
    }

    /** sql映射对象*/
    override  val mapper: IBaseMapper<ENTITY> by lazy {
        val clz = mapperClass ?: IMybatisMapper::class.java
        @Suppress("UNCHECKED_CAST")
        val map = sqlSession.getMapper(clz as Class<IBaseMapper<ENTITY>>)
        map
    }
} // Class SMybatisDao